searchData={"content_type":"text/markdown","items":[{"doc":"This is the ApiAuth module.\n\nIt provides an HMAC authentication system for APIs.","ref":"ApiAuth.html","title":"ApiAuth","type":"module"},{"doc":"Takes a request header and arguments necessary for validating the Authorization header\nand returns true if the request is authentic and false otherwise","ref":"ApiAuth.html#authentic?/5","title":"ApiAuth.authentic?/5","type":"function"},{"doc":"iex> headers = ApiAuth.headers([], \"/path\", \"client_id\", \"secret_key\")\n    ...> ApiAuth.authentic?(headers, \"/path\", \"client_id\", \"secret_key\")\n    true\n\n    iex> headers = ApiAuth.headers([], \"/path\", \"client_id\", \"secret_key\")\n    ...> ApiAuth.authentic?(headers, \"/path\", \"client_id\", \"hacker\")\n    false","ref":"ApiAuth.html#authentic?/5-examples","title":"Examples - ApiAuth.authentic?/5","type":"function"},{"doc":"Takes a keyword list of headers and pulls the client id from the Authorization header\nreturns the {:ok, client_id} or {:error}","ref":"ApiAuth.html#client_id/1","title":"ApiAuth.client_id/1","type":"function"},{"doc":"iex> headers = [Authorization: \"APIAuth-HMAC-SHA256 client_id:v5+Ooq88txd0cFyfSXYn03EFK/NQW9Gepk5YIdkZ4qM=\"]\n    ...> ApiAuth.client_id(headers)\n    {:ok, \"client_id\"}\n\n    iex> headers = []\n    ...> ApiAuth.client_id(headers)\n    :error","ref":"ApiAuth.html#client_id/1-examples","title":"Examples - ApiAuth.client_id/1","type":"function"},{"doc":"Takes a keyword list of headers and arguments necessary for generating the\nAuthorization header and returns an updated keyword list of headers.","ref":"ApiAuth.html#headers/5","title":"ApiAuth.headers/5","type":"function"},{"doc":"iex> [DATE: \"Sat, 01 Jan 2000 00:00:00 GMT\", \"Content-Type\": \"application/json\"]\n    ...> |> ApiAuth.headers(\"/path\", \"client_id\", \"secret_key\",\n    ...>                    method: \"PUT\", content: \"{\\\"foo\\\": \\\"bar\\\"}\")\n    [Authorization: \"APIAuth-HMAC-SHA256 client_id:v5+Ooq88txd0cFyfSXYn03EFK/NQW9Gepk5YIdkZ4qM=\",\n     \"X-APIAuth-Content-Hash\": \"Qm/ATwS/j9tYMdw3u7bc9w9jo34FpoxupfY+ha5Xk3Y=\",\n     DATE: \"Sat, 01 Jan 2000 00:00:00 GMT\",\n     \"Content-Type\": \"application/json\"]","ref":"ApiAuth.html#headers/5-examples","title":"Examples - ApiAuth.headers/5","type":"function"}]}